
; macro to align on an 'n' byte boundary
align   macro n
        org ($ + n - 1) / n * n
        endm

	org 25000
ladybird_gfx
	include "beruska/ladybird.asm"
	rept 64
		db 0,0,0,0,0,0,0,0
	endm
man_scr
	incbin "beruska/man.scr.pck"
	
scarf_gfx
	include "beruska/scarf.asm"
mouth_gfx
	include "beruska/mouth.asm"

mouth_mm	equ mouth_gfx
mouth_b		equ mouth_gfx + 0x0020
mouth_eh	equ mouth_gfx + 0x0040
mouth_rr	equ mouth_gfx + 0x0060
mouth_or	equ mouth_gfx + 0x0080
mouth_ah	equ mouth_gfx + 0x00a0
mouth_p		equ mouth_gfx + 0x00c0

	org 0x8000
	
; set tv_flag for printing (ROM routine)
tv_flag			equ 0x5c3c
	xor a
	ld (tv_flag),a
	
	ld a,56
	ld (23695),a	; set rst10 attribs to black on white
	
;set up interrupts
interrupt_init
			ld hl,0xFE00
			ld de,0xFE01
			ld (hl),0xFD
			ld b,e
			ld c,e	; ld bc,257
			ldir
		
			ld hl,0xFDFD
			ld (hl),0xC3	; opcode for JP
			ld hl,interrupt
			ld (0xFDFE),hl

	ld hl,man_scr
	ld de,0x4000
	call decompr
	
; enable interrupts
			di
			ld a,0xFE
			ld i,a
			im 2
			ei

	ld b,100
fermata0
	halt
	djnz fermata0

	ld bc,50
	call play_speech
	ld hl,mouth_b
	call draw_mouth
	ld bc,50
	call play_speech
	ld hl,mouth_eh
	call draw_mouth
	ld bc,200
	call play_speech
	ld hl,mouth_rr
	call draw_mouth
	ld bc,50
	call play_speech
	ld hl,mouth_or
	call draw_mouth
	ld bc,200
	call play_speech
	ld hl,mouth_eh
	call draw_mouth
	ld bc,50
	call play_speech
	ld hl,mouth_ah		; beruska
	call draw_mouth
	ld bc,400
	call play_speech
	ld hl,mouth_b
	call draw_mouth
	ld bc,200
	call play_speech
	
	ld hl,mouth_p
	call draw_mouth
	ld bc,50
	call play_speech
	ld hl,mouth_or
	call draw_mouth
	ld bc,250
	call play_speech	; do

	ld hl,mouth_eh
	call draw_mouth
	ld bc,50
	call play_speech
	ld hl,mouth_or
	call draw_mouth
	ld bc,150
	call play_speech	; the
	
	ld hl,mouth_rr
	call draw_mouth
	ld bc,50
	call play_speech
	ld hl,mouth_eh
	call draw_mouth
	ld bc,200
	call play_speech
	ld hl,mouth_b
	call draw_mouth
	ld bc,70
	call play_speech	; greet
	
	ld hl,mouth_eh
	call draw_mouth
	ld bc,200
	call play_speech
	ld hl,mouth_b
	call draw_mouth
	ld bc,50
	call play_speech
	ld hl,mouth_mm
	call draw_mouth
	ld bc,300
	call play_speech	; ings
	
	ld b,25
fermata1
	halt
	djnz fermata1

	ld b,6
	xor a
beruska_on
	push bc
	halt
	halt
	halt
	halt
	push af
	call put_beruska
	pop af
	inc a
	pop bc
	djnz beruska_on

	ld b,25
fermata2
	halt
	djnz fermata2
	
; scripted motion
	call greet_print_at
	ld hl,script
scriptlp
	ld a,(hl)
	or a
	jp z,clear_greet
	cp 1
	jp z,lo_squeak
	cp 2
	jp z,mid_squeak
	cp 3
	jp z,hi_squeak
; get here when script code is 4 (or some other value > 3)
	
	ld b,6
beruska_off
	push bc
	halt
	halt
	halt
	halt
	dec b
	ld a,b
	call put_beruska
	pop bc
	djnz beruska_off
	ld a,10
	call put_beruska

	ld b,7
fadeoff
	push bc
	halt
	halt
	halt
	ld hl,0x5800
	inc (hl)
	ld de,0x5801
	ld bc,0x02ff
	ldir
	pop bc
	djnz fadeoff

	di
	im 1
	ei

	ld hl,end_message
	ld bc,end_message_end - end_message
next_endmess
	push bc
	push hl
	ld a,(hl)
	rst 0x0010
	pop hl
	inc hl
	pop bc
	dec bc
	ld a,b
	or c
	jr nz,next_endmess
	
	ld hl,0x2758
	exx
	ret

clear_greet
	push hl
	
	ld b,20
clear_greet_wait
	halt
	djnz clear_greet_wait
	call greet_print_at
	ld b,19
clear_greet_spaces
	push bc
	ld a," "
	rst 0x0010
	pop bc
	djnz clear_greet_spaces
	call greet_print_at
	
	pop hl
	inc hl
	jr scriptlp

lo_squeak
lsqk_printlp
	; first move beruska head
	ld a,9
	push hl
	call put_beruska
	pop hl

	inc hl
	ld a,(hl)
	cp 32
	jr c,done_lsqk_print
	push hl
	rst 0x0010
	pop hl
	jr lsqk_printlp

done_lsqk_print
; put sample here
;	ld b,13
;lsqk_wait
;	halt
;	djnz lsqk_wait

	push hl
	ld hl,lo_squeak_wav
	ld bc,lo_squeak_end - lo_squeak_wav
	call play_sample

	ld a,5
	call put_beruska
	pop hl

	halt
	halt

	jp scriptlp

mid_squeak
msqk_printlp
	; first move beruska head
	ld a,6
	push hl
	call put_beruska
	pop hl

	inc hl
	ld a,(hl)
	cp 32
	jr c,done_msqk_print
	push hl
	rst 0x0010
	pop hl
	jr msqk_printlp

done_msqk_print
; put sample here
;	ld b,13
;msqk_wait
;	halt
;	djnz msqk_wait

	push hl
	ld hl,mid_squeak_wav
	ld bc,mid_squeak_end - mid_squeak_wav
	call play_sample

	ld a,5
	call put_beruska
	pop hl

	halt
	halt

	jp scriptlp

hi_squeak
hsqk_printlp
	; first move beruska head
	push hl
	ld a,7
	call put_beruska
	halt
	halt
	ld a,8
	call put_beruska
	pop hl

	inc hl
	ld a,(hl)
	cp 32
	jr c,done_hsqk_print
	push hl
	rst 0x0010
	pop hl
	jr hsqk_printlp

done_hsqk_print
; put sample here
;	ld b,11
;hsqk_wait
;	halt
;	djnz hsqk_wait

	push hl
	ld hl,hi_squeak_wav
	ld bc,hi_squeak_end - hi_squeak_wav
	call play_sample

	ld a,7
	call put_beruska
	halt
	halt
	ld a,5
	call put_beruska
	pop hl

	halt
	halt

	jp scriptlp

greet_print_at
	ld a,22
	rst 0x0010
	ld a,21
	rst 0x0010
	ld a,10
	rst 0x0010
	ret

; enter with a = beruska frame.
put_beruska
	ld h,a
	ld l,0
	add hl,hl	; 512 bytes per frame
	ld bc,ladybird_gfx
	add hl,bc
	
	ld de,0x5000
	ld b,64
spritelp
	push bc
	push de
	rept 8
		ldi
	endm
	pop de
	call upde
	pop bc
	djnz spritelp
	ret

interrupt
	push af
	push bc
	push de
	push hl
	call move_scarf
	pop hl
	pop de
	pop bc
	pop af
	ei
	ret

draw_mouth
	ld de,0x40ef
	ld b,16
mouth_lp
	push bc
	push de
	ldi
	ldi
	pop de
	call upde
	pop bc
	djnz mouth_lp
	ret

play_speech
	ld hl,speech_wav
play_sample
samlp
	ld e,(hl)
	rept 8
		srl e
		sbc a,a
		or 0x07
		out (254),a
		ld a,16
		dec a
		jr nz,$ - 1
	endm
	inc hl
	dec bc
	ld a,b
	or c
	jr nz,samlp
	ld (play_speech+1),hl
	ret

move_scarf
scarf_count
	ld a,16
	dec a
	jr nz,no_move_scarf
scarf_pos
	ld a,0
	inc a
	and 0x03
	ld (scarf_pos+1),a
	
	ld l,a
	ld h,scarf_frameset / 0x0100
	ld l,(hl)
	ld h,0
	add hl,hl	; x32 to get image offset
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,scarf_gfx
	add hl,de
	
	ld de,0x48af
	ld b,16
scarf_draw
	push bc
	push de
	ldi
	ldi
	pop de
	call upde
	pop bc
	djnz scarf_draw
	
	ld a,16
no_move_scarf
	ld (scarf_count+1),a
	
	ret
		
frameset
	defb 0,1,2,3,4,5,6,5,7,8,5,9,5,4,3,2,1,0
framesetend
	
upde
	inc d
	ld a,d
	and 7
	ret nz
	ld a,e
	add a,32
	ld e,a
	ret c
	ld a,d
	sub 8
	ld d,a
	ret

decompr
	include "debitbust.asm"
	
script
	; fvr organisers
	defb 2, "ze", 3, "ro", 1, "team", 0
	defb 1, "d", 3, "mag", 2, "ic", 0
	defb 2, "sa", 2, "tan", 1, "tron", 3, "ic", 0
	
	; speccy people
	defb 3, "ate ", 1, "bit", 0
	defb 2, "raww ", 1, "arse", 0
	defb 3, "m", 2, "b-", 3, "ma", 3, "ni", 2, "ax", 0
	defb 1, "k", 3, "3", 2, "l", 0
	defb 1, "pa", 3, "ti", 2, "so", 2, "ners", 0
	defb 3, "3", 3, "s", 1, "c", 0
	defb 2, "to", 2, "tal ", 1, "com", 3, "pu", 2, "ter ", 2, "gang", 0
	defb 2, "c", 2, "i", 1, "5 ", 3, "the ", 2, "am", 1, "a", 1, "ters", 0
	defb 3, "u", 2, "n", 1, "s", 0
	
	; other people
	defb 2, "pro", 2, "to", 1, "vis", 1, "ion", 0
	defb 3, "ras", 2, "ter", 0
	defb 1, "pi", 3, "no", 3, "ki", 2, "o", 0
	defb 3, "grey", 1, "scale", 0
	
	defb 0
	defb 1, "and ", 3, "all", 0
	defb 1, "for", 3, "e", 3, "ver", 0
	defb 2, "vi", 2, "si", 1, "tors", 0
	defb 4

end_message
	defb 22,0,12, "the end."
	defb 22,1,12, "========"
	
	defb 22,3,0,  "Haluzkynation by Hooy-Program"
	defb 22,4,19, "for Forever 7"
	
	defb 22,6,0,  "code......................gasman"
	defb          "music.....................gasman"
	defb          "graphics (part 1).........gasman"
	defb          "vocals....................gasman"

	defb 22,11,1, "with apologies to Marek Fisher"
	
	defb 22,13,1, "See you at next year's party,"
	defb 22,14,0, "by which time I might finish my"
	defb 22,15,9, "_real_ demo..."
	
	defb 22,17,12, "- gasman, 2006-03-18"
	
end_message_end
	
	align 0x100
scarf_frameset
	defb 0,1,2,1
	
speech_wav
	incbin "beruska/speech.bin"
	
hi_squeak_wav
	incbin "beruska/hi_squeak.bin"
hi_squeak_end

mid_squeak_wav
	incbin "beruska/mid_squeak.bin"
mid_squeak_end

lo_squeak_wav
	incbin "beruska/lo_squeak.bin"
lo_squeak_end
