	org 0x8000
	
	xor a
	out (254),a
	ld hl,0x5800
	ld de,0x5801
	ld (hl),l
	ld bc,767
	ldir

;set up interrupts
interrupt_init
			ld hl,0xFE00
			ld de,0xFE01
			ld (hl),0xFD
			ld b,e
			ld c,e	; ld bc,257
			ldir
		
			ld hl,0xFDFD
			ld (hl),0xC3	; opcode for JP
			ld hl,interrupt
			ld (0xFDFE),hl

	ld hl,music
	call stc_init

; set notegfx as udg
	ld hl,notegfx
	ld de,65368
	ld bc,8
	ldir

; set tv_flag for printing (ROM routine)
tv_flag			equ 0x5c3c
	xor a
	ld (tv_flag),a
	
	ld a,7
	ld (23695),a	; set rst10 attribs to white on black	
	
; enable interrupts
			di
			ld a,0xFE
			ld i,a
			im 2
			ei

;	jp ahead ; TEMP

	ld hl,title1
	ld de,0x4000
	call decompress

	ld b,100
zzz1
	halt
	djnz zzz1
	
	ld b,7
fade1
	halt
	halt
	halt
	halt
	halt
	halt
	push bc
	ld hl,0x5800
	ld de,0x5801
	ld bc,0x02ff
	inc (hl)
	ldir
	pop bc
	djnz fade1
		
	ld b,200
zzz2
	halt
	djnz zzz2

	ld b,7
fade2
	halt
	halt
	halt
	halt
	halt
	halt
	push bc
	ld hl,0x5800
	ld de,0x5801
	ld bc,0x02ff
	dec (hl)
	ldir
	pop bc
	djnz fade2

	ld hl,title2
	ld de,0x4000
	call decompress

	ld b,7
fade3
	halt
	halt
	halt
	halt
	halt
	halt
	push bc
	ld hl,0x5800
	ld de,0x5801
	ld bc,0x02ff
	inc (hl)
	ldir
	pop bc
	djnz fade3
		
	ld b,200
zzz3
	halt
	djnz zzz3

	ld b,7
fade4
	halt
	halt
	halt
	halt
	halt
	halt
	push bc
	ld hl,0x5800
	ld de,0x5801
	ld bc,0x02ff
	dec (hl)
	ldir
	pop bc
	djnz fade4
	
ahead:

	ld hl,0x4000
	ld de,0x4001
	ld bc,0x17ff
	ld (hl),l
	ldir

	ld b,0x40
	ld hl,0x0c40
stars
	ld e,(hl)
	inc hl
	ld a,(hl)
	inc hl
	and 0x0f
	or 0x40
	ld d,a
	ld a,(hl)
	and 0x07
	ld c,a
	xor a
	scf
shiftstar
	rla
	dec c
	jr nz,shiftstar
	
	ld (de),a
	djnz stars
	
	ld hl,firstbit
	ld b,8
	ld de,0x50a0
put1
	push bc
	push de
	ld bc,32
	ldir
	pop de
	inc d
	pop bc
	djnz put1
	ld b,8
	ld de,0x50c0
put2
	push bc
	push de
	ld bc,32
	ldir
	pop de
	inc d
	pop bc
	djnz put2
	ld b,8
	ld de,0x50e0
put3
	push bc
	push de
	ld bc,32
	ldir
	pop de
	inc d
	pop bc
	djnz put3
	
scrollspeed EQU 4
	ld bc,432 * scrollspeed
main1
	halt
	push bc
	
mainfadect
	ld a,5
	dec a
	jr nz,nomainfade
	
fadestage
	ld a,0
	inc a
	cp 8
	jr z,skipmainfade
	ld (fadestage+1),a
	ld hl,0x5a00
	ld (hl),a
	ld de,0x5a01
	ld bc,0x001e
	ldir
	inc e
	ld hl,0x5a00
	ld bc,0x00e0
	ldir
	
skipmainfade
	ld a,6
nomainfade
	ld (mainfadect+1),a

maintwinkct
	ld a,4
	dec a
	jr nz,nomaintwink
	
twinkpos
	ld hl,0
	inc hl
	ld (twinkpos+1),hl
	ld de,0x5800
	ld b,0
twinklp
	ld a,(hl)
	and 7
	ld (de),a
	inc hl
	inc de
	djnz twinklp
twinklp2
	ld a,(hl)
	and 7
	ld (de),a
	inc hl
	inc de
	djnz twinklp2
	
	ld a,8
nomaintwink
	ld (maintwinkct+1),a

mainscrollct
	ld a,1
	dec a
	jr nz,nomainscroll
	call scroll
		; call scroll 512 times
	ld a,scrollspeed
nomainscroll
	ld (mainscrollct+1),a

	pop bc
	dec bc
	ld a,b
	or c	
	jr nz, main1
	
	ld b,80
main2
	push bc
	halt
	halt
	call scroll
	halt
	halt
	call fadestars
	halt
	pop bc
	djnz main2
	
; clear stars
	ld hl,0x4000
	ld de,0x4001
	ld (hl),l
	ld bc,0x0fff
	ldir
; set back to cyan
	ld hl,0x5800
	ld de,0x5801
	ld (hl),5
	ld bc,0x1ff
	ldir
	
	ld b,70
fermata1
	halt
	djnz fermata1
	
; spaceship descent
	ld b,40
ship_descent
	push bc
	halt
	call move_bigship
	halt
	call move_bigship
	halt
	call move_smallship1
	call move_smallship2
	pop bc
	djnz ship_descent

	ld b,20
ship_descent2
	push bc
	halt
	call move_bigship
	halt
	halt
	call move_bigship
	halt
	call move_smallship1
	call move_smallship2
	pop bc
	djnz ship_descent2

	ld b,90
fermata2
	halt
	djnz fermata2
	
	call close_encounter

	ld bc,305
fermata3
	halt
	dec bc
	ld a,b
	or c
	jr nz,fermata3

	call mussorgsky

	ld b,145
fermata4
	halt
	djnz fermata4

; print "?????"
	call wtfprintat
	ld b,5
wtflp
	push bc
	rept 5
		halt
	endm
	ld a,"?"
	rst 0x0010
	pop bc
	djnz wtflp
	
	ld b,100
fermata5
	halt
	djnz fermata5

	call unwtf

	call close_encounter

	ld b,125
fermata6
	halt
	djnz fermata6

	call mussorgsky

	ld b,15
fermata7
	halt
	djnz fermata7
	call unwtf
	
; print "!!!!!"
	call wtfprintat
	ld b,5
wtf2lp
	push bc
	rept 5
		halt
	endm
	ld a,"!"
	rst 0x0010
	pop bc
	djnz wtf2lp
	
	ld b,50
fermata7p5
	halt
	djnz fermata7p5
	call unwtf
	
	ld b,15
fermata8
	halt
	djnz fermata8

	ld b,10
blitz
	push bc
	halt
	ld de,0x5000
	call blitzfade
	halt
	ld de,0x5100
	call blitzfade
	halt
	ld de,0x5200
	call blitzfade
	halt
	ld de,0x5300
	call blitzfade
	halt
	ld hl,0x5800
	ld de,0x5801
	ld bc,0x02ff
	ld (hl),56
	ldir
	ld a,7
	out (254),a
	halt
	ld de,0x5400
	call blitzfade
	halt
	ld de,0x5500
	call blitzfade
	halt
	ld de,0x5600
	call blitzfade
	halt
	ld de,0x5700
	call blitzfade
	halt
	halt
	ld hl,0x5800
	ld de,0x5801
	ld bc,0x02ff
	ld (hl),7
	ldir
	xor a
	out (254),a
	pop bc
	djnz blitz

	ld b,50
fermata9
	halt
	djnz fermata9
	
	ld b,7
finalfade
	push bc
	rept 8
		halt
	endm
	dec b
	ld hl,0x5800
	ld de,0x5801
	ld (hl),b
	ld bc,0x02ff
	ldir
	pop bc
	djnz finalfade

	im 1
	ld hl,0x2758
	exx
	ret

blitzfade
	; enter with de = screen pos
blitzpos
	ld hl,0
	ld b,0
	push hl
blitzlp
	ld a,(de)
	and (hl)
	ld (de),a
	inc de
	inc hl
	djnz blitzlp
	
	pop hl
	inc hl
	ld (blitzpos+1),hl
	ret

wtfprintat
	ld a,22
	rst 0x0010
	ld a,5
	rst 0x0010
	ld a,18
	rst 0x0010
	ret

unwtf
; clear "?????"
	call wtfprintat
	ld b,5
unwtflp
	push bc
	rept 5
		halt
	endm
	ld a," "
	rst 0x0010
	pop bc
	djnz unwtflp
	ret

close_encounter
	ld a,0x46
	call shiplite
	call cenote_pause
	ld a,0x47
	call shiplite
	call cenote_pause
	ld a,0x44
	call shiplite
	call cenote_pause
	ld a,0x42
	call shiplite
	call cenote_pause
	ld a,0x43
	call shiplite
	call cenote_pause
	call cenote_pause
	call cenote_pause
	ld a,0x05
	call shiplite
	ret

mussorgsky
	ld b,10
	ld hl,muss_data
muss_note
	push bc
	ld b,4
muss_char
	push bc
	push hl
	ld a,(hl)
	rst 0x0010
	pop hl
	inc hl
	pop bc
	djnz muss_char
	
	call halfnote_pause
	
	pop bc
	djnz muss_note
	
	ld b,30
muss_fermata
	halt
	djnz muss_fermata
	
	ld b,40
muss_clear
	push bc
	push hl
	ld a,(hl)
	rst 0x0010
	pop hl
	inc hl
	pop bc
	djnz muss_clear
	
	ret

cenote_pause
	ld b,33
celp
	halt
	djnz celp
	ret

halfnote_pause
	ld b,11
hnlp
	halt
	djnz hnlp
	ret

move_bigship
	ld hl,ship_big_gfx
ship_pos
	ld de,0x380b
	push de
	
	ld b,72
bigship_lp
	push bc
	push de
	
	rept 13
		ldi
	endm
	
	pop de
	call upde
	pop bc
	djnz bigship_lp
	
	pop de
	call upde
	ld (ship_pos+1),de
	ret
	
shiplite
	ld (22891),a
	ld (22924),a
	ld (22925),a
	ld (22957),a
	ld (22958),a
	ld (22959),a
	ld (22990),a
	ld (22991),a
	ld (22992),a
	ld (22993),a
	ld (22994),a
	ld (23026),a
	ld (22995),a
	ld (22962),a
	ld (22963),a
	ld (22964),a
	ld (22965),a
	ld (22932),a
	ld (22933),a
	ld (22934),a
	ld (22966),a
	ld (22935),a
	ld (22902),a
	ld (22903),a
	ld (22892),a
	ld (22893),a
	ld (22926),a
	ld (22960),a
	ret
	
move_smallship1
	ld hl,ship_small_gfx
ship_pos1
	ld de,0x3882
	push de
	
	ld b,40
smallship_lp1
	push bc
	push de
	
	rept 7
		ldi
	endm
	
	pop de
	call upde
	pop bc
	djnz smallship_lp1
	
	pop de
	call upde
	ld (ship_pos1+1),de
	ret

move_smallship2
	ld hl,ship_small_gfx
ship_pos2
	ld de,0x3898
	push de
	
	ld b,40
smallship_lp2
	push bc
	push de
	
	rept 7
		ldi
	endm
	
	pop de
	call upde
	pop bc
	djnz smallship_lp2
	
	pop de
	call upde
	ld (ship_pos2+1),de
	ret

upde
	inc d
	ld a,d
	and 7
	ret nz
	ld a,e
	add a,32
	ld e,a
	ret c
	ld a,d
	sub 8
	ld d,a
	ret

fadestars
	ld hl,0x5800
	call fstartwice
fstartwice
	ld b,0
fstarlp
	ld a,(hl)
	and a
	jr z,nofstar
	dec a
	ld (hl),a
nofstar
	inc hl
	djnz fstarlp
	ret

scroll
	ld b,8
	ld hl,0x505f
scroll1
	push hl
	sla (hl)
	rept 31
		dec l
		rl (hl)
	endm
	pop hl
	inc h
	djnz scroll1
	
	ld b,8
	ld hl,0x507f
scroll2
	push hl
	sla (hl)
	rept 31
		dec l
		rl (hl)
	endm
	pop hl
	inc h
	djnz scroll2
	
	ld b,8
	ld hl,0x509f
scroll3
	push hl
	sla (hl)
	rept 31
		dec l
		rl (hl)
	endm
	pop hl
	inc h
	djnz scroll3

	ld b,8
	ld hl,0x50bf
scroll4
	push hl
	sla (hl)
	rept 31
		dec l
		rl (hl)
	endm
	pop hl
	inc h
	djnz scroll4
	
	ld b,8
	ld hl,0x50df
scroll5
	push hl
	sla (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	pop hl
	inc h
	djnz scroll5

	ld b,8
	ld hl,0x50ff
scroll6
	push hl
	sla (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	dec l
	rl (hl)
	pop hl
	inc h
	djnz scroll6

scrollcount
	ld a,0x80
	rrc a
	ld (scrollcount+1),a
	jp nc,nodraw

drawpos
	ld hl,lastbit
	ld de,0x505f
	ldi
	ld de,0x515f
	ldi
	ld de,0x525f
	ldi
	ld de,0x535f
	ldi
	ld de,0x545f
	ldi
	ld de,0x555f
	ldi
	ld de,0x565f
	ldi
	ld de,0x575f
	ldi
	ld de,0x507f
	ldi
	ld de,0x517f
	ldi
	ld de,0x527f
	ldi
	ld de,0x537f
	ldi
	ld de,0x547f
	ldi
	ld de,0x557f
	ldi
	ld de,0x567f
	ldi
	ld de,0x577f
	ldi
	ld de,0x509f
	ldi
	ld de,0x519f
	ldi
	ld de,0x529f
	ldi
	ld de,0x539f
	ldi
	ld de,0x549f
	ldi
	ld de,0x559f
	ldi
	ld de,0x569f
	ldi
	ld de,0x579f
	ldi
	ld de,0x50bf
	ldi
	ld de,0x51bf
	ldi
	ld de,0x52bf
	ldi
	ld de,0x53bf
	ldi
	ld de,0x54bf
	ldi
	ld de,0x55bf
	ldi
	ld de,0x56bf
	ldi
	ld de,0x57bf
	ldi
	ld de,0x50df
	ldi
	ld de,0x51df
	ldi
	ld de,0x52df
	ldi
	ld de,0x53df
	ldi
	ld de,0x54df
	ldi
	ld de,0x55df
	ldi
	ld de,0x56df
	ldi
	ld de,0x57df
	ldi
	ld de,0x50ff
	ldi
	ld de,0x51ff
	ldi
	ld de,0x52ff
	ldi
	ld de,0x53ff
	ldi
	ld de,0x54ff
	ldi
	ld de,0x55ff
	ldi
	ld de,0x56ff
	ldi
	ld de,0x57ff
	ldi
	ld (drawpos+1),hl

nodraw
	ret
;	pop bc
;	dec bc
;	ld a,b
;	or c
;	ret

interrupt
	push af
	push bc
	push de
	push hl
	push ix
	call stc_play
	pop ix
	pop hl
	pop de
	pop bc
	pop af
	ei
	ret

firstbit	
	include sr/firstbit.asm
	
lastbit
	include sr/lastbit.asm
	
ship_big_gfx
	include sr/ship_big.asm
	
ship_small_gfx
	include sr/ship_small.asm
	
stplayer
	include sr/stc_player.asm
music
	incbin sr/srskaven.stc
	
decompress
	if megalz
		include dec40.asm
	else
		include debitbust.asm
	endif
	
title1
	if megalz
		incbin sr/title1.scr.mlz
	else
		incbin sr/title1.scr.pck
	endif
title2
	if megalz
		incbin sr/title2.scr.mlz
	else
		incbin sr/title2.scr.pck
	endif
	
muss_data	
	defb 22,16,20,144
	defb 22,16,20,144
	defb 22,17,22,144
	defb 22,17,22,144
	defb 22,16,24,144
	defb 22,16,24,144
	defb 22,15,26,144
	defb 22,14,27,144
	defb 22,17,29,144
	defb 22,17,29,144

	defb 22,16,20,32
	defb 22,16,20,32
	defb 22,17,22,32
	defb 22,17,22,32
	defb 22,16,24,32
	defb 22,16,24,32
	defb 22,15,26,32
	defb 22,14,27,32
	defb 22,17,29,32
	defb 22,17,29,32

notegfx
	db 0x07, 0x39,0x21, 0x21, 0x23, 0x67, 0xe2, 0x40